/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Annotation of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 227 - (hide annotations)
Tue Sep 7 16:02:12 2010 UTC (13 years, 7 months ago) by dpavlin
File MIME type: application/x-sh
File size: 5131 byte(s)
don't try to start containers without rootfs mounted

1 dpavlin 184 #! /bin/sh
2     ### BEGIN INIT INFO
3     # Provides: lxc-watchdog
4     # Required-Start: $remote_fs $named $network $time
5     # Required-Stop: $remote_fs $named $network
6     # Required-Start:
7     # Required-Stop:
8     # Default-Start: 2 3 4 5
9     # Default-Stop: 0 1 6
10     # Short-Description: Manage Linux Containers startup/shutdown
11     # Description: Uses clever inotify hack to monitor container's
12     # halt/reboot events watching /var/run/utmp
13     ### END INIT INFO
14 root 175
15 dpavlin 184 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 dpavlin 181 #
17 dpavlin 184 # based on Tony Risinger post to lxc-users mailing list
18 root 175 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 root 190 #
20     # Install with:
21     # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22     # update-rc.d lxc-watchdog defaults
23 root 175
24 dpavlin 181
25 dpavlin 177 which inotifywait >/dev/null || apt-get install inotify-tools
26 root 175
27    
28 dpavlin 181 lxc_exists() {
29     name=$1
30 root 175
31 dpavlin 181 if [ ! -e /var/lib/lxc/$name/config ] ; then
32     echo "Usage: $0 name"
33     lxc_status
34     exit 1
35     fi
36     }
37 root 175
38 dpavlin 179
39 dpavlin 181 lxc_rootfs() {
40 dpavlin 194 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 dpavlin 181 }
42 dpavlin 178
43 root 175
44 dpavlin 183 lxc_status() {
45 dpavlin 196 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46     boot="-"
47 dpavlin 216 hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48     ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49 dpavlin 189 test -s /var/lib/lxc/$name/on_boot && boot="boot"
50 dpavlin 216 echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51 dpavlin 196 done ) | column -t
52 dpavlin 183 }
53    
54    
55 dpavlin 181 cleanup_init_scripts() {
56     rootfs=$(lxc_rootfs $1)
57 dpavlin 179
58 dpavlin 181 ls \
59     $rootfs/etc/rc?.d/*umountfs \
60     $rootfs/etc/rc?.d/*umountroot \
61     $rootfs/etc/rc?.d/*hwclock* \
62 root 218 $rootfs/etc/rc?.d/*udev* \
63 dpavlin 181 2>/dev/null | xargs -i rm -v {}
64 dpavlin 226
65     echo $1 > $rootfs/etc/hostname
66 dpavlin 181 }
67 dpavlin 179
68 dpavlin 181
69     setup_inittab() {
70     rootfs=$(lxc_rootfs $1)
71 dpavlin 183 remove=$2
72     add=$3
73 dpavlin 181
74     # let container respond to kill -SIGPWR
75     inittab=$rootfs/etc/inittab
76 dpavlin 227 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
77 dpavlin 183 grep -v "$remove" ${inittab} > ${inittab}.new
78     echo $add >> ${inittab}.new
79 dpavlin 181 mv ${inittab}.new ${inittab}
80 dpavlin 183 echo "$inittab modified with $add"
81 dpavlin 181 fi
82     }
83    
84    
85 dpavlin 189 lxc_log() {
86     echo `date +%Y-%m-%dT%H:%M:%S` $*
87     }
88    
89    
90 dpavlin 183 lxc_kill() {
91 dpavlin 181 name=$1
92 dpavlin 183 sig=$2
93 dpavlin 181
94     init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
95     if [ -z "$init_pid" ] ; then
96     lxc-info -n $name
97     exit 1
98     fi
99 dpavlin 189 lxc_log "$name kill $sig $init_pid"
100 dpavlin 183 /bin/kill $sig $init_pid
101     }
102    
103     lxc_stop() {
104 dpavlin 189 lxc_log "$name stop"
105 dpavlin 183 lxc_kill $name -SIGPWR
106 dpavlin 179 lxc-wait -n $name -s STOPPED
107 dpavlin 189 lxc_log "$name stoped"
108 dpavlin 183 # rm -f /var/lib/lxc/${name}/on_boot
109 dpavlin 181 }
110 dpavlin 179
111    
112 dpavlin 181 lxc_start() {
113     name=$1
114 dpavlin 227 rootfs=$(lxc_rootfs $1)
115 dpavlin 181
116 dpavlin 227 if [ ! -e $rootfs ] ; then
117     echo "ERROR $name rootfs $rootfs not found"
118     return
119     fi
120    
121 dpavlin 181 if ! lxc-info -n $name | grep RUNNING ; then
122 dpavlin 189 lxc_log "$name start"
123 dpavlin 181 lxc-start -n $name -o /tmp/${name}.log -d
124     lxc-wait -n $name -s RUNNING
125     lxc-info -n $name
126 dpavlin 185 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
127 dpavlin 181 fi
128     }
129    
130     lxc_watchdog() {
131     name=$1
132     rootfs=$(lxc_rootfs $1)
133    
134 root 175 while true; do
135     vps_utmp=${rootfs}/var/run/utmp
136 dpavlin 181 tasks=`wc -l < /cgroup/${name}/tasks`
137     test -z "$tasks" && exit 1
138     if [ "$tasks" -eq 1 ]; then
139 root 175
140     runlevel="$(runlevel ${vps_utmp})"
141 dpavlin 187 lxc_log "$name runlevel $runlevel"
142 root 175
143     case $runlevel in
144     N*)
145     # nothing for new boot state
146     ;;
147     ??0)
148 dpavlin 187 lxc_log "$name halt"
149 root 175 lxc-stop -n "${name}"
150 dpavlin 181 lxc-wait -n ${name} -s STOPPED
151 root 175 break
152     ;;
153     ??6)
154 dpavlin 187 lxc_log "$name reboot";
155 root 175 lxc-stop -n ${name}
156     lxc-wait -n ${name} -s STOPPED
157     lxc-start -d -n ${name} -o /tmp/${name}.log
158     ;;
159     *)
160     # make sure vps is still running
161     state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
162     [ "$state" = "RUNNING" ] || break
163     ;;
164     esac
165 dpavlin 181 else
166 dpavlin 187 lxc_log "$name $tasks tasks"
167 root 175 fi
168 dpavlin 182
169     # time of 5 minutes on it JUST IN CASE...
170     inotifywait -qqt 300 ${vps_utmp}
171 root 175 done
172    
173 dpavlin 189 lxc_log "$name watchdog exited"
174 dpavlin 181
175     }
176    
177    
178 root 190 usage() {
179     echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
180     exit 3
181     }
182    
183 dpavlin 183 command_on_lxc() {
184     command=$1
185     shift
186 dpavlin 181
187 dpavlin 183 echo "# $command $1"
188    
189     case "$command" in
190    
191 dpavlin 181 start)
192 dpavlin 183 lxc_exists $1
193     cleanup_init_scripts $1
194 dpavlin 193 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
195     setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
196     setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
197 dpavlin 183 lxc_start $1
198 dpavlin 186 # give container 5 seconds to start more than one process
199     ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
200 dpavlin 181 ;;
201 dpavlin 183 stop|halt)
202     lxc_exists $1
203     lxc_stop $1
204 dpavlin 181 ;;
205 dpavlin 183 reload|force-reload|restart|reboot)
206     lxc_kill $1 -SIGINT
207 dpavlin 181 ;;
208     watchdog)
209 dpavlin 183 lxc_watchdog $1
210 dpavlin 181 ;;
211 dpavlin 188 boot)
212     echo $1 > /var/lib/lxc/$1/on_boot
213     ;;
214     disable)
215     echo -n > /var/lib/lxc/$1/on_boot
216     ;;
217 dpavlin 181 *)
218 root 190 usage
219 dpavlin 181 ;;
220    
221     esac
222    
223 dpavlin 183 }
224    
225     command=$1
226 root 190 test -z "$command" && usage
227     test "$command" = "status" && lxc_status && exit
228 dpavlin 189 shift
229 dpavlin 183
230     if [ -z "$1" ] ; then
231     ls /var/lib/lxc/*/on_boot | while read path ; do
232     name=`echo $path | cut -d/ -f5`
233 dpavlin 189 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
234     command_on_lxc $command $name
235     else
236     echo "# skip $command $name"
237     fi
238 dpavlin 183 done
239     else
240     while [ ! -z "$1" ] ; do
241     command_on_lxc $command $1
242     shift
243     done
244     fi
245    

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26